// carriers
// carry your teammates

globalvar carriers;
carriers = id;

// "Required plugins should automatically set themselves to required"
global.serverPluginsRequired = 1;

// CONSTS
//
//
//		ACTIONS
GRAB			= 0;
RELEASE			= 3;
WELCOME			= 7;
//		MODE when you carry:
//			you can either use your weapon and be slow,
//			or run faster and not be able to
MODE_RUN		= 1;
MODE_SHOOT		= 2;
//		ENABLE or disable
//			you can prevent players from carrying you
CARRY_ENABLE	= 8;
CARRY_DISABLE	= 9;

RUN_SLOWDOWN_PER_PLAYER		= 0.05;
SHOOT_SLOWDOWN_PER_PLAYER	= 0.075;
RUN_SLOWDOWN				= 0.9 + RUN_SLOWDOWN_PER_PLAYER;
INTEL_SLOWDOWN				= 0.8;
SHOOT_SLOWDOWN				= 0.65 + SHOOT_SLOWDOWN_PER_PLAYER;
MIN_SPEED					= 0.2;


// PERSISTENT VARS
//
//
ini_open("gg2.ini");
grabKey		= ini_read_real("Plugins", "carriers_grabKey", ord("Q"));
modeKey		= ini_read_real("Plugins", "carriers_modeKey", ord("V"));
carryEnable	= ini_read_real("Plugins", "carriers_enable", true);
ini_close();

// OBJECTS
//
//
NetworkController = object_add();
object_set_persistent(NetworkController, true);














// MENUS
//
//
OptionMenu = object_add();
object_set_parent(OptionMenu,MenuController);  
object_set_depth(OptionMenu,-130000); 
object_event_add(OptionMenu,ev_create,0,'   
	menu_create(48, 172, 500, 260, 32, 40, 104, 6);
	menumode = true;

	if room != Options {
		menu_setdimmed();
	}
	
	menu_background(512, 24, 8, 12, 4);
    bgtabs = false;
	
	menu_addedit_boolean("Allow carrying", "carriers.carryEnable", "
        return argument0;
    ");
	
	menu_addedit_key("Grab Key", "carriers.grabKey");
	menu_addlink("The key used to carry/jump on the back of a teammate", "");
	
	menu_addedit_key("Run/Shoot Key", "carriers.modeKey");
	menu_addlink("When carrying someone, use this key to run faster/use your weapon", "");

    menu_addback("Back", "
        instance_destroy();
        if(room == Options)
            room_goto_fix(Menu);
        else
            instance_create(0,0,InGameMenuController);
    ");
');

object_event_add(OptionMenu,ev_destroy,0,'
	with(carriers) {
		ini_open("gg2.ini");
		ini_write_real("Plugins","carriers_grabKey",grabKey);
		ini_write_real("Plugins","carriers_modeKey",modeKey);
		ini_write_real("Plugins","carriers_enable",carryEnable);
		ini_close();
		if(room != Options) {
			global.myself.carryEnable = carryEnable;
			// I KNOW NETWORKING HERE IS BAD BUT WHATEVER
			var enableByte;
			if(carryEnable)	enableByte = carriers.CARRY_ENABLE;
			else			enableByte = carriers.CARRY_DISABLE;
			if(global.isHost) {
				write_ubyte(carriers.NetworkController.sendBuffer, enableByte);
				write_ubyte(carriers.NetworkController.sendBuffer, ds_list_find_index(global.players, global.myself));
			} else {
				write_ubyte(carriers.NetworkController.sendBuffer, enableByte);
			}
		}
	}
');

object_event_add(InGameMenuController,ev_create,0,'
	menu_addlink("Carriers Options", "
		instance_destroy();
		instance_create(0,0,carriers.OptionMenu);
	");
'); 
















// SCRIPT
//
//
object_event_add(Player, ev_create, 0, '
	carryEnable	= true;
');
object_event_add(Player, ev_step, ev_step_begin, '
	if(not variable_local_exists("carryEnable")) {
		carryEnable	= true;
	}
');
object_event_add(Character, ev_create, 0, '
	carrier				= noone;
	carry				= noone;
	carryRunning		= true;
	originalRunPower	= runPower;
');
object_event_add(Character, ev_step, ev_step_begin, '
	if(not variable_local_exists("carrier")) {
		carrier				= noone;
		carry				= noone;
		originalRunPower	= runPower;
		carryRunning		= true;
	}
');
object_event_add(Character, ev_destroy, 0, '
	with(carrier) {
		carry = noone;
	}
	with(carry) {
		x = other.x;
		if(other.player.class == CLASS_QUOTE) {
			y = other.y - 12;
		} else {
			y = other.y;
		}
		carrier = noone;
	}
	carrier	= noone;
	carry	= noone;
');

//	//	//	"PHYSICS" RUN HERE
object_event_add(Character, ev_step, ev_step_begin, '
	currentWeapon.visible = true;
	if(carrier == noone) {
		
		// run power
		runPower = originalRunPower;
		if(player.class == CLASS_SNIPER)
		if(zoomed)
			runPower = 0.6;
		if(player.class == CLASS_HEAVY)
		if(keyState & $10) {
			runPower = 0.3;
		}
		if(player.class == CLASS_SPY)
		if(stabbing)
			runPower = 0;
			
		if(carry != noone) {
			if(carryRunning) {
				runPower = max(carriers.MIN_SPEED, runPower * (carriers.RUN_SLOWDOWN - execute_string(carriers.stackHeight, id) * carriers.SHOOT_SLOWDOWN_PER_PLAYER));
			} else {
				runPower = max(carriers.MIN_SPEED, runPower * (carriers.SHOOT_SLOWDOWN - execute_string(carriers.stackHeight, id) * carriers.RUN_SLOWDOWN_PER_PLAYER));
			}
			
			// gotta redo that because of the if/else above
			if(player.class == CLASS_SPY)
			if(stabbing)
				runPower = 0;
			
			if(execute_string(carriers.stackHasIntel, id)) {
				runPower *= carriers.INTEL_SLOWDOWN;
			}
			
			// carrier weapon disabling
			if(carryRunning) {
				with(currentWeapon) {
					readyToShoot = false;
					if(variable_local_exists("refireTime"))
						alarm[0] = refireTime / global.delta_factor;
					var al5;
					al5 = 0;
					if(variable_local_exists("reloadBuffer"))
						al5 += reloadBuffer;
					if(variable_local_exists("reloadTime"))
						al5 += reloadTime;
					al5 /= global.delta_factor;
					alarm[5] = al5;
					visible = false;
				}
			}
		}
	}
');

object_event_add(Character, ev_step, ev_step_end, '
	if(carry != noone) {
		// carried players position
		if(player.class != CLASS_QUOTE) {
			carry.x = floor(x - (8 * image_xscale));
		} else {
			carry.x = floor(x);
		}
		carry.y = floor(y - 18);
		carry.hspeed = hspeed;
		carry.vspeed = vspeed;
	}
');

// after testing, DSM seems to screw Gate
// so I have to use IntelGate and TeamGate instead :z7:
object_event_add(Character, ev_collision, IntelGate, '
	if(carry != noone) {
		execute_string(carriers.doRelease, player);
	}
');
object_event_add(Character, ev_collision, TeamGate, '
	if(carry != noone) {
		execute_string(carriers.doRelease, player);
	}
');

// gets closest carryable Character from Player arg0
// argument0: Player
getCarryable = '
	var closestChar, charDist, thatDist, sendingPlayer;
	sendingPlayer = argument0;
	closestChar = noone;
	if(sendingPlayer.object != -1)
	if(sendingPlayer.object.carry == noone) 
	if(sendingPlayer.object.carrier == noone) {
		charDist = 30;
		with(Character) {
			if(id != sendingPlayer.object)
			if((team == sendingPlayer.team) or ((player.class == CLASS_QUOTE) and not (sendingPlayer.object.cloak)))
			if(player.carryEnable)
			if(carrier == noone) {
				
				thatDist = distance_to_object(sendingPlayer.object);
				if(thatDist < charDist) {
					if(collision_line(x, y,	sendingPlayer.object.x, sendingPlayer.object.y,	Obstacle, true, false) <= 0) {
						if(collision_line(x, y,	sendingPlayer.object.x, sendingPlayer.object.y,	IntelGate, true, false) <= 0)
						if(collision_line(x, y,	sendingPlayer.object.x, sendingPlayer.object.y,	TeamGate, true, false) <= 0) {
							if(collision_line(x, y,	sendingPlayer.object.x, sendingPlayer.object.y,	PlayerWall, true, false) <= 0) {
								charDist = thatDist;
								closestChar = id;
							}
						}
					}
				}
			}
		}
		if(closestChar != noone) {
			closestChar = closestChar.player;
		}
	}
	return closestChar;
';

// returns how many people are in the stack starting from arg0
// argument0: a Character
stackHeight = '
	var carrier, height;
	carrier = argument0;
	height = 0;
	while(carrier != noone) {
		height += 1;
		carrier = carrier.carry;
	}
	return height;
';

// returns whether someone in the carry stack has intel
// argument0: a Character
stackHasIntel = '
	var carrier;
	carrier = argument0;
	while(carrier != noone) {
		if(carrier.intel) {
			return true;
		}
		carrier = carrier.carry;
	}
	return false;
';

// checks if argument0 (Player) can grab argument1 (Player)
// basic check: 
checkGrab = '
	var sending, grabbed;
	sending = argument0;
	grabbed = argument1;
	if(sending != noone)
	if(grabbed != noone)
	if(grabbed.carryEnable)
	if(sending.object != -1)
	if(grabbed.object != -1)
		return true;
	return false;
';

// writes argument0 (Player) grabbed argument1 (Player) into argument2 (buffer)
sendGrab = '
	write_ubyte(argument2, carriers.GRAB);
	write_ubyte(argument2, ds_list_find_index(global.players, argument0));
	write_ubyte(argument2, ds_list_find_index(global.players, argument1));
';

doGrab = '
	var sending, grabbed;
	sending = argument0;
	grabbed = argument1;
	if(sending.object != -1) {
		if(sending.object.carry != noone) {
			execute_string(carriers.doRelease, sending, sending.object.carry);
		}
		sending.object.carry = grabbed.object;
		grabbed.object.carrier = sending.object;
		if(sending.class == CLASS_SPY) {
			with(sending.object.currentWeapon) {
				readyToStab = false;
				alarm[1] = StabreloadTime / global.delta_factor;
			}
		}
	}
';

// writes argument0 (Player) releases/is released into argument1 (buffer)
sendRelease = '
	write_ubyte(argument1, carriers.RELEASE);
	write_ubyte(argument1, ds_list_find_index(global.players, argument0));
';

doRelease = '
	var sending;
	sending = argument0;
	if(sending != noone)
	if(sending.object != -1) {
		// if sender is carrying
		if(sending.object.carry != noone) {
			sending.object.carry.x = sending.object.x;
			sending.object.carry.y = sending.object.y;
			if(sending.class == CLASS_QUOTE) {
				sending.object.carry.y = sending.object.y - 12;
			}
			sending.object.carry.carrier = noone;
			sending.object.carry = noone;
		}
		// if sender is carried
		if(sending.object.carrier != noone) {
			sending.object.x = sending.object.carrier.x;
			sending.object.y = sending.object.carrier.y;
			if(sending.class == CLASS_QUOTE) {
				sending.object.y = sending.object.carrier.y - 12;
			}
			sending.object.carrier.carry = noone;
			sending.object.carrier = noone;
		}
	}
';

// writes byte argument0 from player argument1 into argument2
sendByteFrom = '
	write_ubyte(argument2, argument0);
	write_ubyte(argument2, ds_list_find_index(global.players, argument1));
';














// CONTROLS
//
//
object_event_add(PlayerControl, ev_create, 0, '
	with(global.myself) {
		carryEnable	= carriers.carryEnable;
	}
');
object_event_add(PlayerControl, ev_step, ev_step_normal, '
	if(not variable_local_exists("global.myself.carryEnable")) {
		with(global.myself) {
			carryEnable	= carriers.carryEnable;
		}
	}
');
object_event_add(PlayerControl, ev_step, ev_step_normal, '
	if(global.myself.object != -1)
	with(carriers) {
		if(keyboard_check_pressed(grabKey)) {
			var grabbedPlayer;
			// GRAB/RELEASE AS HOST
			if(global.isHost) {
				if((global.myself.object.carrier == noone)
					and (global.myself.object.carry == noone))
				{
					grabbedPlayer = execute_string(getCarryable, global.myself);
					if(grabbedPlayer != noone) {
						execute_string(sendGrab, global.myself, grabbedPlayer, NetworkController.sendBuffer);
						execute_string(doGrab, global.myself, grabbedPlayer);
					}
				} else {
					execute_string(sendRelease, global.myself, NetworkController.sendBuffer);
					execute_string(doRelease, global.myself, NetworkController.sendBuffer);
				}
			// GRAB/RELEASE AS CLIENT
			} else {
				if((global.myself.object.carrier == noone)
					and (global.myself.object.carry == noone))
				{
					write_ubyte(NetworkController.sendBuffer, GRAB);
				} else {
					write_ubyte(NetworkController.sendBuffer, RELEASE);
				}
			}
		}
		if(keyboard_check_pressed(modeKey)) {
			// MODE AS HOST
			if(global.isHost) {
				global.myself.object.carryRunning = !global.myself.object.carryRunning;
				if(global.myself.object.carryRunning) {
					execute_string(sendByteFrom, MODE_SHOOT, global.myself, NetworkController.sendBuffer);
				} else {
					execute_string(sendByteFrom, MODE_RUN, global.myself, NetworkController.sendBuffer);
				}
			// MODE AS CLIENT
			} else {
				if(global.myself.object.carryRunning) {
					write_ubyte(NetworkController.sendBuffer, MODE_SHOOT);
				} else {
					write_ubyte(NetworkController.sendBuffer, MODE_RUN);
				}
			}
		}
	}
');














// NETWORK
//
//
object_event_add(PlayerControl, ev_step, ev_step_normal, '
	if(not instance_exists(carriers.NetworkController)) {
		instance_create(x,y,carriers.NetworkController);
	}
');

object_event_add(NetworkController, ev_create, 0, '
	sendBuffer = buffer_create();
	if(not global.isHost) {
		with(carriers) {
			if(global.myself.carryEnable)	write_ubyte(other.sendBuffer, CARRY_ENABLE);
			else							write_ubyte(other.sendBuffer, CARRY_DISABLE);
		}
	}
');
object_event_add(NetworkController, ev_destroy, 0, '
	buffer_destroy(sendBuffer);
');
object_event_add(NetworkController, ev_step, ev_step_begin, '
	with(carriers) {
		var readBuffer, sendingPlayer, sendBuffer, read;
		sendBuffer = other.sendBuffer;
		while(PluginPacketGetBuffer(packetID) != -1) {
			readBuffer = PluginPacketGetBuffer(packetID);
			read = read_ubyte(readBuffer);
			switch(read) {
				case GRAB:
					var grabbedPlayer;
					if(global.isHost) {
						sendingPlayer = PluginPacketGetPlayer(packetID);
						grabbedPlayer = execute_string(getCarryable, sendingPlayer);
						if(execute_string(checkGrab, sendingPlayer, grabbedPlayer)) {
							execute_string(sendGrab, sendingPlayer, grabbedPlayer, sendBuffer);
							execute_string(doGrab, sendingPlayer, grabbedPlayer);
						}
					} else {
						sendingPlayer = ds_list_find_value(global.players, read_ubyte(readBuffer));
						grabbedPlayer = ds_list_find_value(global.players, read_ubyte(readBuffer));
						execute_string(doGrab, sendingPlayer, grabbedPlayer);
					}
					break;
				case RELEASE:
					if(global.isHost) {
						sendingPlayer = PluginPacketGetPlayer(packetID);
						execute_string(sendRelease, sendingPlayer, sendBuffer);
					} else {
						sendingPlayer = ds_list_find_value(global.players, read_ubyte(readBuffer));
					}
					execute_string(doRelease, sendingPlayer);
					break;
				case MODE_RUN:
					if(global.isHost) {
						sendingPlayer = PluginPacketGetPlayer(packetID);
						write_ubyte(sendBuffer, MODE_RUN);
						write_ubyte(sendBuffer, ds_list_find_index(global.players, sendingPlayer));
					} else {
						sendingPlayer = ds_list_find_value(global.players, read_ubyte(readBuffer));
					}
					if(sendingPlayer.object != -1)
					sendingPlayer.object.carryRunning = true;
					break;
				case MODE_SHOOT:
					if(global.isHost) {
						sendingPlayer = PluginPacketGetPlayer(packetID);
						write_ubyte(sendBuffer, MODE_SHOOT);
						write_ubyte(sendBuffer, ds_list_find_index(global.players, sendingPlayer));
					} else {
						sendingPlayer = ds_list_find_value(global.players, read_ubyte(readBuffer));
					}
					if(sendingPlayer.object != -1)
					sendingPlayer.object.carryRunning = false;
					break;
				case CARRY_ENABLE:
					if(global.isHost) {
						sendingPlayer = PluginPacketGetPlayer(packetID);
						write_ubyte(sendBuffer, CARRY_ENABLE);
						write_ubyte(sendBuffer, ds_list_find_index(global.players, sendingPlayer));
					} else {
						sendingPlayer = ds_list_find_value(global.players, read_ubyte(readBuffer));
					}
					sendingPlayer.carryEnable = true;
					break;
				case CARRY_DISABLE:
					if(global.isHost) {
						sendingPlayer = PluginPacketGetPlayer(packetID);
						write_ubyte(sendBuffer, CARRY_DISABLE);
						write_ubyte(sendBuffer, ds_list_find_index(global.players, sendingPlayer));
					} else {
						sendingPlayer = ds_list_find_value(global.players, read_ubyte(readBuffer));
					}
					sendingPlayer.carryEnable = false;
					break;
			}
			PluginPacketPop(packetID);
			readBuffer = PluginPacketGetBuffer(packetID);
		}
		if(buffer_size(sendBuffer) > 0) {
			PluginPacketSend(packetID, sendBuffer);
			buffer_clear(sendBuffer);
		}
	}
');









// SYNC
//
//
object_event_add(Character, ev_other, ev_user12, '
    if(global.updateType == QUICK_UPDATE or global.updateType == FULL_UPDATE) {
		if(carrier == noone) {
			write_ubyte(global.serializeBuffer, 255);
		} else {
			write_ubyte(global.serializeBuffer, ds_list_find_index(global.players, carrier.player));
		}
		if(carry == noone) {
			write_ubyte(global.serializeBuffer, 255);
		} else {
			write_ubyte(global.serializeBuffer, ds_list_find_index(global.players, carry.player));
		}
		write_ubyte(global.serializeBuffer, carryRunning);
	}
');


object_event_add(Player, ev_other, ev_user12, '
	if(global.updateType == FULL_UPDATE) {
		write_ubyte(global.serializeBuffer, carryEnable);
	}
');

object_event_add(Character, ev_other, ev_user13, '
    if(global.updateType == QUICK_UPDATE or global.updateType == FULL_UPDATE) {
		receiveCompleteMessage(global.serverSocket,3,global.deserializeBuffer);
		carrier = read_ubyte(global.deserializeBuffer);
		if(carrier == 255) {
			carrier = noone;
		} else {
			carrier = ds_list_find_value(global.players, carrier).object;
		}
		carry = read_ubyte(global.deserializeBuffer);
		if(carry == 255) {
			carry = noone;
		} else {
			carry = ds_list_find_value(global.players, carry).object;
		}
		carryRunning = read_ubyte(global.deserializeBuffer);
	}
');

object_event_add(Player, ev_other, ev_user13, '
	if(global.updateType == FULL_UPDATE) {
		receiveCompleteMessage(global.serverSocket,1,global.deserializeBuffer);
		carryEnable	= read_ubyte(global.deserializeBuffer);
		
	}
');